Function CreateTable(Data)

	CreateTable = "<table border='1'>" & Data & "</table>"

End Function

Function GetAttribute(node, AttributeName)

	GetAttribute = ""
	Dim attributes
	Set attributes = node.attributes
	Counter = 0
	While Counter < attributes.length
		Dim attr
		Set attr = attributes.Item(Counter)
		If attr.nodeName = AttributeName Then
			GetAttribute = attr.nodeValue
			Exit Function
		End If
		Counter = Counter + 1
	Wend

End Function

Function ProcessTryings(TestNode)

        Dim TryNodes
	Set TryNodes = TestNode.childNodes
	ProcessTryings = TryNodes.length

End Function


Function ProcessResults(TestNode, WorstResult, BestResult)

	WorstResult = -1
	BestResult = 0
	CommonResult = CInt( 0 )

	Dim TryNodeNext
	Set TryNodeNext = TestNode.firstChild
	while Not TryNodeNext Is Nothing
		Dim TryNodePrev
		Set TryNodePrev = TryNodeNext

		RightAnswers = CInt( GetAttribute(TryNodeNext, "RightAnswers") )
		If RightAnswers > BestResult Then BestResult = RightAnswers
		If RightAnswers < WorstResult or WorstResult = -1 Then WorstResult = RightAnswers
		CommonResult = CommonResult + RightAnswers
		
		Set TryNodeNext = TryNodePrev.nextSibling	
	Wend

	ProcessResults = CommonResult

End Function

Function GetColor(mark, best)

	GetColor = "white"

	If CInt(mark) = CInt(best) Then
		GetColor = "magenta"
	ElseIf mark < (best/3) Then
		GetColor = "red"
	ElseIf mark < (2*best/3) Then
		GetColor = "yellow"
	ElseIf mark < best Then
		GetColor = "lightgreen"
	End If
	
End Function

Function ProcessTests(root, TestsNumber)

	TestsNumber = 0
	ProcessTests = ""
	Dim CommonResults, WorstResult, BestResult
	Dim TestNamesTable, TryingsTable, WorstResultTable, BestResultTable, MiddleResultTable
	Dim TestNodeNext
	Set TestNodeNext = root.firstChild
	while Not TestNodeNext Is Nothing
		Dim TestNodePrev
		Set TestNodePrev = TestNodeNext
		TestNamesTable = "<td align='left'>" & GetAttribute(TestNodeNext, "Name") & "</td>"
		AllQuestionNumber = GetAttribute(TestNodeNext, "QuestionNumber")
		TryingsNumber = ProcessTryings(TestNodeNext)
		TryingsTable = "<td>" & TryingsNumber & "</td>"

		CommonResults = ProcessResults(TestNodeNext, WorstResult, BestResult)

		WorstResultTable = "<th><font color='" & GetColor( WorstResult , AllQuestionNumber ) & "'>" & WorstResult & "</font> ( " & AllQuestionNumber & ")</th>"
		BestResultTable  = "<th><font color='" & GetColor( BestResult , AllQuestionNumber ) & "'>" & BestResult & "</font> ( " & AllQuestionNumber & ")</th>"

		ExactMiddleResult = CommonResults / TryingsNumber
		MiddleResult = Round ( ExactMiddleResult, 2 )
		MiddleResultTable = "<th bgcolor='" & GetColor(CommonResults, AllQuestionNumber * TryingsNumber) & "'>"

		MiddleResultTable = MiddleResultTable & MiddleResult & " ( " & AllQuestionNumber & ")</th>"

		TestsNumber = TestsNumber + 1

		If TestsNumber > 1 Then
			UserStatisticsRow = UserStatisticsRow & "<tr align='center'>"
		End If
		UserStatisticsRow = UserStatisticsRow & TestNamesTable & TryingsTable & WorstResultTable & BestResultTable & MiddleResultTable

		Set TestNodeNext = TestNodePrev.nextSibling
	Wend

	ProcessTests = UserStatisticsRow

End Function

Function ParseUserInfo(FilePath, FileName)

	ParseUserInfo = ""
	Dim pDoc
	Set pDoc = CreateObject("Msxml2.FreeThreadedDOMDocument.4.0")
	pDoc.async = False
	vbResult = pDoc.load(FilePath)

	If vbResult = True Then

		Dim root
		Set root = pDoc.documentElement
		StatisticsNodeName = root.nodeName

		If StatisticsNodeName = "Statistics" Then
			Dim TestsNumber, UserStatisticsRow
			UserStatisticsRow = ProcessTests(root, TestsNumber)

			ParseUserInfo = "<td rowspan='" & TestsNumber & "' align='left'>" & Split(FileName,".res.xml")(0) & "</td>" & UserStatisticsRow
			
		End If
		
	End If

End Function

Sub Main()

	Dim FileSystemObject, StatisticsFolder

	Set FileSystemObject = CreateObject("Scripting.FileSystemObject")
	If FileSystemObject.FolderExists(strStatisticsFolder) = False Then
		document.write " -     : """ & strStatisticsFolder & """. <BR>        !"
	Else
		document.write "<table border='1' width='100%'>"
		document.write "<caption><h2>   </h2></caption>"
		document.write "<tr><th></th><th></th><th> </th><th> , </th><th> , </th><th> *</th><tr>"
		Set StatisticsFolder = FileSystemObject.GetFolder(strStatisticsFolder)
		Set Files = StatisticsFolder.Files
		If Files.Count <> 0 Then
		   For Each File In Files
		      	document.write "<tr align='center'>" & ParseUserInfo( strStatisticsFolder & "\" & File.Name, File.Name ) & "</tr>"
		   Next
		End If
		document.write "</table>"
	End If

	document.write "<BR>* -       .</BR>"
	document.write "<H3>:</H3>"
	document.write "<table><tr><td bgcolor='magenta'></td><tr><tr><td bgcolor='lightgreen'></td><tr><tr><td bgcolor='yellow'></td><tr><tr><td bgcolor='red'></td><tr></table>"

End Sub

Main

